// -*- Mode:C++ -*-
//Header:
//File: BpLinkBase.h
//Author: NODA, Itsuki
//Date: 1999/12/16
//

//ModifyHistory:
// 1999/12/16: Start to create this file
// 1999/12/26: reconfigulation
//EndModifyHistory:

#ifndef _Nnn_BpLinkBase_h_
#define _Nnn_BpLinkBase_h_
////////////////////////////////////////////////////////////////////////

#include "n3btype.h"
#include "n3utility.h"
#include "StrForm.h"
#include "LinkBase.h"

namespace Nnn {

   using namespace Itk ;

   //======================================================================
   // LinkBase

   class BpLinkBase : public LinkBase {

      public:
	 static char* const sformTermHead = "BpL" ; // used in save/load
	 static char* const sformWeightLbl = "w" ;  // used in save/load
	 //--------------------------------------------------
	 // member
      public:
	 Val dw ;

	 //--------------------------------------------------
	 // constructor
      public:
	 BpLinkBase() : LinkBase() { dw = 0.0 ; } ;

	 //--------------------------------------------------
	 // save 
      public:
	 virtual void save(ostream & ostr) const ;

	 //--------------------------------------------------
	 // load
      public:
	 virtual void scan(StrForm & sform) ;

	 //--------------------------------------------------
	 // describe
      public:
	 virtual void describe(ostream & ostr, 
			       const Bool detailp = True) const {
	    ostr << "#BpLinkBase[" 
		 << "w=" << NNN_VAL_FORMAT << w
		 << "]" ;

	    if(detailp) {
	       ostr << endl ;
	       ostr << "\t" << "dw=" << NNN_VAL_FORMAT << dw << endl ;
	    } 
	 } ;
   } ;

} ;
////////////////////////////////////////////////////////////////////////
#endif
