// -*- Mode:C++ -*-
//Header:
//File: LinkBase.h
//Author: NODA, Itsuki
//Date: 1999/12/16
//

//ModifyHistory:
// 1999/12/16: Start to create this file
// 1999/12/26: reconfigulation
//EndModifyHistory:

#ifndef _Nnn_LinkBase_h_
#define _Nnn_LinkBase_h_
////////////////////////////////////////////////////////////////////////

#include "n3btype.h"
#include "n3utility.h"
#include "StrForm.h"

namespace Nnn {

   using namespace Itk ;

   //======================================================================
   // LinkBase

   class LinkBase : public WithDescriber {

      public:
	 static char* const sformTermHead = "L" ; // used in save/load
	 static char* const sformWeightLbl = "w" ;  // used in save/load
	 //--------------------------------------------------
	 // member
      public:
	 Val w ;

	 //--------------------------------------------------
	 // constructor
      public:
	 LinkBase() { w = 0.0 ; } ;
	 LinkBase(const Val & iw) { w = iw ; } ;
	 LinkBase(const LinkBase& l) { w = l.w ; } ;

	 //--------------------------------------------------
	 // save 
      public:
	 virtual void save(ostream & ostr) const ;

	 //--------------------------------------------------
	 // load
      public:
	 virtual void load(istream & istr) {
	    StrForm * sform = StrForm::scan(istr) ;
	    scan(*sform) ;
	    delete sform ;
	 } ;

      public:
	 virtual void scan(StrForm & sform) ;

	 //--------------------------------------------------
	 // describe
      public:
	 virtual void describe(ostream & ostr, 
			       const Bool detailp = True) const {
	    ostr << "#LinkBase[" 
		 << "w=" << NNN_VAL_FORMAT << w
		 << "]" ;

	    if(detailp) {
	       ostr << endl ;
	    } 
	 } ;
   } ;

} ;
////////////////////////////////////////////////////////////////////////
#endif
