// -*- Mode:C++ -*-
//Header:
//File: btype.h
//Author: NODA, Itsuki
//Date: 1999/12/16
//

//ModifyHistory:
// 1999/12/16: Start to create this file
//EndModifyHistory:

#ifndef _Nnn_btype_h_
#define _Nnn_btype_h_
////////////////////////////////////////////////////////////////////////

#include <stl.h>
#include <math.h>
#include "itk/itk.h"

#define NNN_VAL_FORMAT_W 7
#define NNN_VAL_FORMAT_P 3

#define NNN_VAL_FORM(width,prec) setiosflags(ios::fixed) << setfill(' ') \
                         << setw(width) << setprecision(prec)

#define NNN_VAL_FORMAT	NNN_VAL_FORM(NNN_VAL_FORMAT_W,NNN_VAL_FORMAT_P)
#define NNN_VAL_FORMAT2	NNN_VAL_FORM(10,6)
#define NNN_VAL_FORMAT3	NNN_VAL_FORM(20,16)


namespace Nnn {

   using namespace Itk ;

   typedef UInt ID ;
   typedef UInt Index ;
   typedef Index Size ;

   typedef Flt Val ;

   enum SaveLevel { 
      SL_NetState, 	// save threshold and weight
      SL_RunState,	// save with netinput and activation
      SL_AllState	// save with dw and dh, err, and so on
   } ;

   const Val Eps = 1.0e-10 ;

} ;
////////////////////////////////////////////////////////////////////////
#endif
