#include "n3btype.h"
#include "n3utility.h"
#include "fstream.h"
#include "stdlib.h"

using namespace Itk ;
using namespace Nnn ;

//--------------------------------------------------
void test1() { 
   ITK_MSG("====================== test 1 ======================") ;
   
   Val x ;
   ITK_DBG(x=3) ;
   ITK_DBG(sq(x)) ;
}

//--------------------------------------------------
void test2() {
   ITK_MSG("====================== test 2 ======================") ;

   {
      ofstream out("tmp/a") ;
      for(Val x = -10.0 ; x < 10.0 ; x += 0.1) 
	 out << x << " " << sigmoid(x,1) << endl ;
   }

   {
      ofstream out("tmp/b") ;
      for(Val x = -10.0 ; x < 10.0 ; x += 0.1) 
	 out << x << " " << d_sigmoid(x,sigmoid(x,1),1) << endl ;
   }
   
   {
      ofstream out("tmp/c") ;
      for(Val x = -10.0 ; x < 10.0 ; x += 0.1) 
	 out << x << " " << bigmoid(x,1) << endl ;
   }
   
   {
      ofstream out("tmp/d") ;
      for(Val x = -10.0 ; x < 10.0 ; x += 0.1) 
	 out << x << " " << d_bigmoid(x,bigmoid(x,1),1) << endl ;
   }

   cout << "Do " << endl 
	<< "\t" << "% cd tmp ; gnuplot" << endl 
	<< "\t" << "plot \"a\",\"b\",\"c\",\"d\"" << endl ;
   
}

#if 0

//--------------------------------------------------
void test3() { 
   ITK_MSG("====================== test 3 ======================") ;
   
   BpUnit u0 ;
   ITK_DSC(u0) ;

   ITK_DBG(u0.inp=-2.5) ;
   ITK_DSC(u0) ;

   ITK_EXE(u0.foreProp()) ;
   ITK_DSC(u0) ;
   
}

//--------------------------------------------------
void test4() { 
   ITK_MSG("====================== test 4 ======================") ;

   randomizeByTime() ;

   BpUnit i1, i2 ;
   BpUnit h1, h2 ;
   BpUnit o1 ;

   BpLink ih11(&i1,&h1), ih12(&i1,&h2), ih21(&i2,&h1), ih22(&i2,&h2) ;
   BpLink ho11(&h1, &o1), ho21(&h2, &o1) ;

   ITK_DSC(h1) ;
   ITK_DSC(ih22) ;

   ITK_DBG(ih11.w = fltRand(-1,1)); ITK_DBG(ih12.w = fltRand(-1,1));
   ITK_DBG(ih21.w = fltRand(-1,1)); ITK_DBG(ih22.w = fltRand(-1,1));
   ITK_DBG(ho11.w = fltRand(-1,1)); ITK_DBG(ho21.w = fltRand(-1,1));

   ITK_DBG(h1.thr = fltRand(-1,1)) ; ITK_DBG(h2.thr = fltRand(-1,1)) ;

   ITK_DBG(o1.thr = fltRand(-1,1)) ; 

   ITK_DBG(i1.out = (Val)intRand(1)) ; 
   ITK_DBG(i2.out = (Val)intRand(1)) ;

   ITK_EXE(h1.foreProp()) ; ITK_DSC(h1) ;
   ITK_EXE(h2.foreProp()) ; ITK_DSC(h2) ;

   ITK_EXE(o1.foreProp()) ; ITK_DSC(o1) ;
}

//--------------------------------------------------
#include "Buffer.h"

void test5() { 
   ITK_MSG("====================== test 5 ======================") ;

   Buffer buf(1) ;
   ITK_DSC(buf) ;
   ITK_EXE(buf.putCharSafe('a')) ;
   ITK_DSC(buf) ;
   ITK_EXE(buf.putCharSafe('b')) ;
   ITK_DSC(buf) ;
   ITK_EXE(buf.putCharSafe('c')) ;
   ITK_DSC(buf) ;
   ITK_DBG(buf) ;
}	 

#endif  

//--------------------------------------------------
#include "StrForm.h"

void test6() { 
   ITK_MSG("====================== test 6 ======================") ;

   Buffer buf(1024) ;
   buf.put("#a[ b=3, c = 21 | a , \"That's a nice , %  this is not a comment
		but \\\"is\\\" is good\",  % this is a comment
                #b[|a,b,c,d,e]]") ;
//   buf.put("a") ;
   ITK_DBG(buf) ;
   StrForm * f ;
   ITK_DBG(f = StrForm::scan(buf));
   ITK_DBG(*f) ;
   ITK_DSC(*f) ;
} ;

//--------------------------------------------------

void test7() { 
   ITK_MSG("====================== test 7 ======================") ;

   ifstream f("foo.dat") ;
   Buffer b = StrForm::prescan(f) ;
   ITK_DBG(b) ;
   StrForm *sf ;
   ITK_EXE(sf = StrForm::scan(b)) ;
   ITK_DBG(*sf) ;
   ITK_DSC(*sf) ;
}

//--------------------------------------------------

void test8() { 
   ITK_MSG("====================== test 8 ======================") ;

   ifstream f("foo.dat") ;
   StrForm *sf ;
   ITK_EXE(sf = StrForm::scan(f)) ;
   ITK_DBG(*sf) ;
   ITK_DSC(*sf) ;
   ITK_DBG(*(sf->assoc("baz"))) ;
}

//--------------------------------------------------

#include "UnitBase.h"

void test9() { 
   ITK_MSG("====================== test 9 ======================") ;

   UnitBase u(1.0,2.0,-3.0) ;
   ITK_EXE(u.save(cout)) ;  cout << endl ;
   cout << "enter unitbase strform:" << flush ;
   UnitBase v ;
   v.load(cin) ;
   ITK_DSC(v) ;
   ITK_EXE(v.save(cout)) ;  cout << endl ;
}

//--------------------------------------------------

#include "LinkBase.h"

void test10() { 
   ITK_MSG("====================== test 10 ======================") ;

   LinkBase l(3.14) ;
   ITK_EXE(l.save(cout)) ;  cout << endl ;
   cout << "enter linkbase strform:" << flush ;
   LinkBase l2 ;
   l2.load(cin) ;
   ITK_DSC(l2) ;
   ITK_EXE(l2.save(cout)) ;  cout << endl ;

   
}

//--------------------------------------------------

#include "BpUnitBase.h"
#include "BpLinkBase.h"

void test11() { 
   ITK_MSG("====================== test 11 ======================") ;

   BpUnitBase u1 ; 
   u1.thr = 0.345 ; u1.inp = 1.234 ; u1.out = 2.456 ;
   u1.err = -3.5  ; u1.dlt = -3.45 ; u1.dh = -123.4 ;
   ITK_EXE(u1.save(cout)) ; cout << endl ;
   cout << "enter bpunitbase strform:" << flush ;
   BpUnitBase u2 ;
   u2.load(cin) ;
   ITK_DSC(u2) ;
   ITK_EXE(u2.save(cout)) ;  cout << endl ;
   

   BpLinkBase l1 ; 
   l1.w = 3.14 ; l1.dw = 2.7 ;
   ITK_EXE(l1.save(cout)) ;  cout << endl ;
   cout << "enter bplinkbase strform:" << flush ;
   BpLinkBase l2 ;
   l2.load(cin) ;
   ITK_DSC(l2) ;
   ITK_EXE(l2.save(cout)) ;  cout << endl ;

   
}

//--------------------------------------------------

#include "BpLayer.h"

void test12() { 
   ITK_MSG("====================== test 12 ======================") ;

   BpLayer lyr("test",5) ;

   ITK_DSC(lyr) ;
   ITK_EXE(lyr.save(cout)) ; cout << endl ;

   BpLayer lyr2 ;
   ITK_DSC(lyr2) ;
   cout << "enter bplayer strform:" << flush ;
   ITK_EXE(lyr2.load(cin)) ;

   ITK_DSC(lyr2) ;
   ITK_EXE(lyr2.save(cout)) ; cout << endl ;
}

//--------------------------------------------------

#include "BpLLink.h"

void test13() { 
   ITK_MSG("====================== test 13 ======================") ;

   BpLayerTable layertab ;
   BpLayer lyr1("foo",4) ; layertab.assign(lyr1) ;
   BpLayer lyr2("bar",3) ; layertab.assign(lyr2) ;
   

   ITK_DSC(lyr1) ;
   ITK_DSC(lyr2) ;

   BpLLink lnk(&lyr1,&lyr2) ;
   ITK_DSC(lnk) ;
   ITK_EXE(lnk.save(cout)) ;

   BpLLink lnk2 ;
   ITK_DSC(lnk2) ;
   cout << "enter bp link strform:" << flush ;
   lnk2.load(cin, &layertab) ;
   ITK_DSC(lnk2) ;
   ITK_EXE(lnk2.save(cout)) ; cout << endl ;
}

//--------------------------------------------------

#include "BpNetBase.h"

void test14() { 
   ITK_MSG("====================== test 14 ======================") ;

   BpNetBase net("test") ;

   ITK_DSC(net) ;

   BpLayer input("input",5) ;   net.addLayer(&input) ;
   BpLayer hidden("hidden",4) ; net.addLayer(&hidden) ;
   BpLayer output("output",3) ; net.addLayer(&output) ;
   net.newLLink(&input,&hidden) ;
   net.newLLink(&hidden,&output) ;

   ITK_DSC(net) ;

   ITK_EXE(net.save(cout)) ;

   BpNetBase net2 ;

   ITK_DSC(net2) ;

   cout << "enter bp net strform:" << flush ;
   net2.load(cin) ;
   ITK_DSC(net2) ;
   ITK_EXE(net2.save(cout)) ;

   ITK_DSC(*(net2.layer("hidden"))) ;
   
}

//--------------------------------------------------

void test15() { 
   ITK_MSG("====================== test 15 ======================") ;

   ValVector x(10) ;

   ITK_DBG(x) ;
   ITK_DSC(x) ;
} ;

//--------------------------------------------------

#include "BpNetBase.h"

void test16() { 
   ITK_MSG("====================== test 16 ======================") ;

   BpNetBase net("test") ;

   ITK_DSC(net) ;

   BpLayer input("input",2,BpLayer::FT_linear) ;   net.addLayer(&input) ;
   BpLayer hidden("hidden",2,BpLayer::FT_linear) ; net.addLayer(&hidden) ;
   BpLayer output("output",2,BpLayer::FT_linear) ; net.addLayer(&output) ;
   BpLLink * lnkIH = net.newLLink(&input,&hidden) ;
   BpLLink * lnkHO = net.newLLink(&hidden,&output) ;

   ITK_EXE(hidden.unit(0).thr =  1) ;
   ITK_EXE(hidden.unit(1).thr = -1) ;
   ITK_EXE(output.unit(0).thr = -1) ;
   ITK_EXE(output.unit(1).thr =  1) ;
   ITK_EXE(lnkIH->link(0,0).w = 1) ;
   ITK_EXE(lnkIH->link(0,1).w = 2) ;
   ITK_EXE(lnkIH->link(1,0).w = 3) ;
   ITK_EXE(lnkIH->link(1,1).w = 4) ;

   ITK_EXE(lnkHO->link(0,0).w = 5) ;
   ITK_EXE(lnkHO->link(0,1).w = 6) ;
   ITK_EXE(lnkHO->link(1,0).w = 7) ;
   ITK_EXE(lnkHO->link(1,1).w = 8) ;

   ValVector inp(2) ;
   ValVector out(2) ;
   ITK_EXE({inp[0] = 1 ; inp[1] = 2 ;}) ;
   ITK_EXE(input.propFore(inp,1.0)) ;
   ITK_EXE(hidden.propFore(1.0)) ;
   ITK_EXE(output.propFore(100.0)) ;
   ITK_EXE(output.getNetOutput(out)) ;

   ITK_DSC(out) ;
   
}



//--------------------------------------------------

#include "ValVector.h"

void test17() { 
   ITK_MSG("====================== test 17 ======================") ;
   
   ValVector v(50) ;
   
   v.randomize(-1,1) ;
   
   ITK_DBG(v) ;
   ITK_DSC(v) ;

   ITK_EXE(v.save(cout)) ; cout << endl ;

   ValVector v2 ;
   ITK_DSC(v2) ;
   cout << "Enter ValVector sform:" << flush ;
   v2.load(cin) ;
   ITK_DSC(v2) ;
   
} ;

//--------------------------------------------------

#include "BpNetBase.h"

void test18() { 
   ITK_MSG("====================== test 18 ======================") ;

   BpNetBase net("test") ;

   ITK_DSC(net) ;

   BpLayer * input = net.newLayer("input",2) ;
   BpLayer * hidden = net.newLayer("hidden",2,BpLayer::FT_linear) ; 
   BpLayer * output = net.newLayer("output",2,BpLayer::FT_linear) ; 
   BpLLink * lnkIH = net.newLLink(input,hidden) ;
   BpLLink * lnkHO = net.newLLink(hidden,output) ;

   ITK_EXE(hidden->randomizeThreshold(-1,1)) ;
   ITK_EXE(output->randomizeThreshold(-1,1)) ;
   ITK_EXE(lnkIH->randomizeWeight(-1,1)) ;
   ITK_EXE(lnkHO->randomizeWeight(-1,1)) ;

   ValVector inp(2) ;
   ValVector out(2) ;
   ValVector tch(2) ;

   for(UInt i = 0 ; i < 50 ; i++) {
      inp[0] = 1 ; inp[1] = 2 ;
      tch[0] = 3 ; tch[1] = 4 ;

      input->propFore(inp,1.0) ;
      hidden->propFore(1.0) ;
      output->propFore(1.0) ;
      output->getNetOutput(out) ;
      
      output->propBack(tch,1.0) ;
      hidden->propBack(1.0) ;

      ITK_DSC(out) ;
      ITK_DBG(output->sumError()) ;

      Val r = 0.0 ;
      r += hidden->learn(0.01,0.0) ;
      r += output->learn(0.01,0.0) ;
      r += lnkIH->learn(0.01,0.0) ;
      r += lnkHO->learn(0.01,0.0) ;

      //ITK_DBG(r) ;
   }
}

//--------------------------------------------------

#include "BpNet3SigLyr.h"

void test19() { 
   ITK_MSG("====================== test 19 ======================") ;

   BpNet3SigLyr net("test-3lyr",2,5,1) ;
   net.randomize(-1,1) ;

   ITK_EXE(net.save(cout)) ;
   cout << "Enter Network StrForm:" << flush ;

   BpNet3SigLyr net2 ;
   net2.load(cin) ;
   ITK_DSC(net2) ;
   ITK_EXE(net2.save(cout)) ;
}
   
   
//--------------------------------------------------

#include "BpNet3SigLyr.h"

void test20() { 
   ITK_MSG("====================== test 20 ======================") ;

   BpNet3SigLyr net("test-3lyr",2,5,3,1.0,0.05,0.5) ;
   net.randomize(-1,1) ;

   ValVector i00(2), i01(2), i10(2), i11(2) ;
   ValVector t00(3), t01(3), t10(3), t11(3) ;

   i00[0] = 0 ; i00[1] = 0 ; t00[0] = 0 ; t00[1] = 0 ; t00[2] = 0 ;
   i01[0] = 0 ; i01[1] = 1 ; t01[0] = 0 ; t01[1] = 1 ; t01[2] = 1 ;
   i10[0] = 1 ; i10[1] = 0 ; t10[0] = 0 ; t10[1] = 1 ; t10[2] = 1 ;
   i11[0] = 1 ; i11[1] = 1 ; t11[0] = 1 ; t11[1] = 1 ; t11[2] = 0 ;

   UInt m = 10000 ;

   TimeVal stime ; stime.update() ;

   for(UInt i = 0 ; i < m ; i++) {
      Val err = 0.0 ;

      net.propFore(i00) ; net.propBack(t00) ; net.learn() ; 
      err += net.sumError() ;
      net.propFore(i01) ; net.propBack(t01) ; net.learn() ; 
      err += net.sumError() ;
      net.propFore(i10) ; net.propBack(t10) ; net.learn() ; 
      err += net.sumError() ;
      net.propFore(i11) ; net.propBack(t11) ; net.learn() ; 
      err += net.sumError() ;

      if(i % 1000 == 0) cout << setw(7) << i << ":" << err << endl ;
   }

   TimeVal etime ; etime.update() ;
   ITK_DBG(etime-stime) ;

   ValVector o00(3),o01(3),o10(3),o11(3) ;
   net.propFore(i00) ; net.getNetOutput(o00) ; ITK_DSC(o00) ;
   net.propFore(i01) ; net.getNetOutput(o01) ; ITK_DSC(o01) ;
   net.propFore(i10) ; net.getNetOutput(o10) ; ITK_DSC(o10) ;
   net.propFore(i11) ; net.getNetOutput(o11) ; ITK_DSC(o11) ;

   net.save(cout) ;
   ITK_EXE(net.save("foo.dat")) ;

   BpNet3SigLyr net2 ;
   ITK_EXE(net2.load("foo.dat")) ;
   
   net2.propFore(i00) ; net2.getNetOutput(o00) ; ITK_DSC(o00) ;
   net2.propFore(i01) ; net2.getNetOutput(o01) ; ITK_DSC(o01) ;
   net2.propFore(i10) ; net2.getNetOutput(o10) ; ITK_DSC(o10) ;
   net2.propFore(i11) ; net2.getNetOutput(o11) ; ITK_DSC(o11) ;
}
   

//--------------------------------------------------

#include "BpNet3SigLyr2.h"

void test21() { 
   ITK_MSG("====================== test 21 ======================") ;

   BpNet3SigLyr2 net("test-3lyr",2,5,3,1.0,0.05,0.5) ;
   net.randomize(-1,1) ;

   ValVector i00(2), i01(2), i10(2), i11(2) ;
   ValVector t00(3), t01(3), t10(3), t11(3) ;

   i00[0] = 0 ; i00[1] = 0 ; t00[0] = 0 ; t00[1] = 0 ; t00[2] = 0 ;
   i01[0] = 0 ; i01[1] = 1 ; t01[0] = 0 ; t01[1] = 1 ; t01[2] = 1 ;
   i10[0] = 1 ; i10[1] = 0 ; t10[0] = 0 ; t10[1] = 1 ; t10[2] = 1 ;
   i11[0] = 1 ; i11[1] = 1 ; t11[0] = 1 ; t11[1] = 1 ; t11[2] = 0 ;

   UInt m = 10000 ;

   TimeVal stime ; stime.update() ;

   for(UInt i = 0 ; i < m ; i++) {
      Val err = 0.0 ;

      net.propFore(i00) ; net.propBack(t00) ; net.learn() ; 
      err += net.sumError() ;
      net.propFore(i01) ; net.propBack(t01) ; net.learn() ; 
      err += net.sumError() ;
      net.propFore(i10) ; net.propBack(t10) ; net.learn() ; 
      err += net.sumError() ;
      net.propFore(i11) ; net.propBack(t11) ; net.learn() ; 
      err += net.sumError() ;

      if(i % 1000 == 0) cout << setw(7) << i << ":" << err << endl ;
   }

   TimeVal etime ; etime.update() ;
   ITK_DBG(etime-stime) ;

   ValVector o00(3),o01(3),o10(3),o11(3) ;
   net.propFore(i00) ; net.getNetOutput(o00) ; ITK_DSC(o00) ;
   net.propFore(i01) ; net.getNetOutput(o01) ; ITK_DSC(o01) ;
   net.propFore(i10) ; net.getNetOutput(o10) ; ITK_DSC(o10) ;
   net.propFore(i11) ; net.getNetOutput(o11) ; ITK_DSC(o11) ;

   net.save(cout) ;
   ITK_EXE(net.save("foo.dat")) ;

   BpNet3SigLyr2 net2 ;
   ITK_EXE(net2.load("foo.dat")) ;
   
   net2.propFore(i00) ; net2.getNetOutput(o00) ; ITK_DSC(o00) ;
   net2.propFore(i01) ; net2.getNetOutput(o01) ; ITK_DSC(o01) ;
   net2.propFore(i10) ; net2.getNetOutput(o10) ; ITK_DSC(o10) ;
   net2.propFore(i11) ; net2.getNetOutput(o11) ; ITK_DSC(o11) ;
}
   
//--------------------------------------------------

#include "ValVector.h"

void test22() { 
   ITK_MSG("====================== test 22 ======================") ;

   ValVector x(20) ;
   
   x.save(cout,"  ") ;
} 

//======================================================================
int main(int argc, char* argv[]) {
   //test1() ;
   //test2() ;
   //test3() ;
   //test4() ;
   //test5() ;
   //test6() ;
   //test7() ;
   //test8() ;
   //test9() ;
   //test10() ;
   //test11() ;
   //test12() ;
   //test13() ;
   //test14() ;
   //test15() ;
   //test16() ;
   //test17() ;
   //test18() ;
   //test19() ;
   //test20() ;
   //test21() ;
   test22() ;

   return 0;
}





