#include "VBpNet3L.h"
#include "TrainSetBase.h"

#define NETFILENAME "foo7.net"

using namespace Nnn ;

//======================================================================

class TsXor : public TrainSetBase {
   public:
      UInt c ;

      TsXor() { c = 0 ; } ;

      virtual UInt sizeInp() const { return 2 ; } ;
      virtual UInt sizeTch() const { return 3 ; } ;

      virtual void get(ValVector & inp, ValVector & tch) {
	 UInt c0 = c % 2 ;
	 UInt c1 = (c % 4)/2 ;
	 inp[0] = (Val)c0 ;
	 inp[1] = (Val)c1 ;

	 tch[0] = (Val)(c0 || c1) ;
	 tch[1] = (Val)(c0 && c1) ;
	 tch[2] = (Val)((c0 + c1) % 2) ;

	 c++ ;
      } ;
} ;

//======================================================================
void runLearn(VBpNet3L & net) {
   TsXor tset ;

   ValVector inp(tset.sizeInp()) ;
   ValVector tch(tset.sizeTch()) ;

   UInt m = 100000 ;
   Val err = 0.0 ;
   
   for(UInt i = 0 ; i < m ; i++) {
      tset.get(inp,tch) ;
      net.runLearn(inp,tch) ;
      err *= 0.9 ;
      err += net.sumError() ;
      if(i % 10000 == 0) cout << setw(7) << i << ":" << sqrt(err) << endl ;
   } ;

   ValVector out(tset.sizeTch()) ;
   for(UInt i = 0 ; i < 100 ; i++) {
      tset.get(inp,tch) ;
      net.run(inp) ;
      net.getNetOutput(out) ;
      if(i % 1 == 0) 
	 cout << inp << "/" << out << "/" << tch << endl ;
   }
}

//======================================================================
void doLoadRunSave() {
   VBpNet3L net ;

   net.load(NETFILENAME) ;
   runLearn(net) ;
   net.save(NETFILENAME) ;
}

//======================================================================
int main() {
   doLoadRunSave() ;
} ;

   



