## -*- Mode: Ruby -*-

require 'gtk' ;
require "itkUtility" ;
require "GtkBufferedDrawingArea.rb" ;

module NnnViewer

  ##======================================================================
  ## class UnitWidget

  class XYPlane

    DFLT_sizeX = 500 ;
    DFLT_sizeY = 500 ;

    attr :parent	,true ;
    attr :frame		,true ;
    attr :layout	,true ;
    attr :background	,true ;
    attr :label		,true ;

    attr :sizeX		,true ;
    attr :sizeY		,true ;
    attr :offsetX	,true ;
    attr :offsetY	,true ;
    attr :scaleX	,true ;
    attr :scaleY	,true ;

    ##------------------------------------------------------------
    ## initialize

    def initialize(parent, sizeX=DFLT_sizeX, sizeY=DFLT_sizeY, name=NIL)
      @parent = parent ;
      @sizeX = sizeX ;
      @sizeY = sizeY ;
      @offsetX = @sizeX / 2 ;
      @offsetY = @sizeY / 2 ;
      @scaleX =  4 ;
      @scaleY = -4 ;  ## for natural XY cordination
      
      @frame = Gtk::Frame::new(name) ;
      @parent.add(@frame) ;

      @layout = Gtk::Layout::new(NIL,NIL) ;
      @frame.add(@layout) ;
      @layout.set_size(sizeX,sizeY) ;
      @layout.set_usize(sizeX,sizeY) ;

      # background does not work.  why?
#      setupBackGround() ;
      

      @label = Hash.new() ;
    end

    def setupBackGround()
#      @background = Gtk::BufferedDrawingArea.new(sizeX,sizeY) ;
      @background = Gtk::BufferedDrawingArea.new(200,200) ;
      @layout.put(@background,0,0) ;
      def @background.setup()
	if(super()) 
	  clear() ;
	  @buffer.draw_rectangle(@fgc,FALSE,10,10,100,100) ;
	end
      end
      @background.show() ;
    end

    ##------------------------------------------------------------
    ## set name

    def setName(name)
      @frame.set_label(name) ;
    end

    ##------------------------------------------------------------
    ## assign new label

    def newLabel(id,x,y,pname=NIL)
      pname = id if (pname == NIL) ;
      w = label[id] = Gtk::Label::new(pname)
      _moveLabel(w,x,y,TRUE) ;
      w.show ;
    end

    ##------------------------------------------------------------
    ## set label name

    def setLabelName(id,name)
      label[id].text = name ;
    end

    ##------------------------------------------------------------
    ## move label

    def moveLabel(id,x,y,firstp=FALSE)
      w = label[id] ;
      if(w == NIL) 
	return newLabel(id,x,y) ;
      else
	return _moveLabel(w,x,y,firstp) ;
      end
    end
    
    ##------------------------------------------------------------
    ## raw move label

    def _moveLabel(w,x,y,firstp=FALSE)
      rx =   (x * @scaleX) + @offsetX ;
      ry = - (y * @scaleY) + @offsetY ;

      if(firstp)
	@layout.put(w,rx,ry) ;
      else
	@layout.move(w,rx,ry) ;
      end
    end
    
  end

end

		
