// -*- Mode:C++ -*-
//Header:
//File: SensorInfo.cc
//Title: SensorInfo
//Author: NODA, Itsuki
//Date: 2001/03/05
//

//ModifyHistory:
// 2001/03/05: Start to create this file
//EndModifyHistory:

#include "SensorInfo.h"

namespace Saloo {

   Bool SensorInfo::scan(SimpleSexp & s) {

      UInt len = s.length() ;
      
      if(len < 1) {
	 ITK_WRN("Illegal Input" << s) ;
	 return False ;
      }

      SimpleSexp * tag = s.nth(0) ;

      Bool r = False;

      if      (tag->equal(SC_WORDSTR(See))) {
	 type = T_See ;
//	 r = see.scan(s,teamname) ;
	 r = see.scan(s,qteamname) ;	// in new protocol, needs quote 
	 time = see.time ;
      } 
      else if (tag->equal(SC_WORDSTR(Hear))) {
	 type = T_Hear ;
	 r = hear.scan(s) ;
	 time = hear.time ;
      } 
      else if (tag->equal(SC_WORDSTR(SenseBody))) {
	 type = T_SenseBody ;
	 r = senseBody.scan(s) ;
	 time = senseBody.time ;
      } 
      else if (tag->equal(SC_WORDSTR(FullState))) {
	 type = T_FullState ;
	 r = fullstate.scan(s) ;
	 time = fullstate.time ;
      } 
      else if (tag->equal(SC_WORDSTR(ServerParam))) {
	 type = T_ServerParam ;
	 r = True ; 
	 /* should be insert handle ServerParam info */
      } 
      else if (tag->equal(SC_WORDSTR(PlayerParam))) {
	 type = T_PlayerParam ;
	 r = True ; 
	 /* should be insert handle PlayerParam info */
      } 
      else if (tag->equal(SC_WORDSTR(PlayerType))) {
	 type = T_PlayerType ;
	 r = True ; 
	 /* should be insert handle PlayerType info */
      } 
      else if (tag->equal(SC_WORDSTR(Error))) {
	 type = T_Error ;
	 ITK_WRN("Server returns an Error : sexp=" << s) ;
	 r = False ;
      } 
      else {
	 type = T_Error ;
	 ITK_WRN("Illegal sensor info : sexp=" << s) ;
	 r = False ;
      }

      return r ;
   }
} ;

