// -*- Mode:C++ -*-
//Header:
//File: saloo.cc
//Title: Saloo 
//Author: NODA, Itsuki
//Date: 2001/03/02
//

//ModifyHistory:
// 2001/03/02: Start to create this file
//EndModifyHistory:


#include "SimplePlayer.h"
#include "OnlineCoach.h"
#include "OfflineCoach.h"

using namespace Saloo ;
using namespace Itk ;

//======================================================================
// sub5

int sub5(int argc, char** argv) {
   SimplePlayer player ;
   OnlineCoach coach ;
   OfflineCoach coach0 ;

   player.init() ;
   player.forkSensor() ;

   sleep(1,0) ;

   coach.init() ;
   coach.forkSensor() ;

   coach0.init() ;
   coach0.forkSensor() ;

   for(UInt i = 0 ; i < 100 ; i++) {
      Pos p(fltRand(-50,-1),fltRand(-30,30)) ;
      ITK_DBG(p) ;
      player.move(p) ;
      player.turn(10) ;
      coach.cvSee.lockWait();
      ITK_DBG(coach.sinfo.teammate(0).posdir()) ;
      coach0.sendMoveBall(fltRand(-50,50),fltRand(-30,30)) ;
      coach0.sendChangeMode(PLAYMODE(BeforeKickOff)) ;
   }

   coach0.sendChangeMode(PLAYMODE(PlayOn)) ;

   while(True) {
      player.turn(10) ;
      coach.cvSee.lockWait();
      ITK_DBG(coach.sinfo.teammate(0).posdir()) ;
   }

   return 0 ;
   
}

//======================================================================
// sub4

int sub4(int argc, char** argv) {

   SimplePlayer player ;
   
   player.init() ;
   player.forkSensor() ;

//   enum Mode { M_Error } mode ;

   while(True) {
      if(player.canMove()) {
	 Pos dst(fltRand(-10,0),fltRand(-10,10)) ;
	 player.sendMove(dst);
	 player.sendTurn(60);
      } else {
	 ITK_DSC(player.ball()) ;
	 if        (!player.isBallSeenRecently(10)) {
	    for(UInt i = 0 ; i < 6 ; i++) {
	       player.turn(60) ;
	    }
	 } else if (player.kickable()) {
	    player.kickToAbs(100,player.goalpos()) ;
	 } else {
	    player.turnToAbs(player.ballpos()) ;
	    player.dash(100) ;
	 }
      } 
   }

   return 0 ;
} ;


//======================================================================
// sub3

int sub3(int argc, char** argv) {

   SimplePlayer player ;
   
   player.init() ;

   player.describe(cout) ;

   player.forkSensor() ;

   while(True) {
      player.cvSee.lockWait() ;
      Pos dst(fltRand(-50,0),fltRand(-30,30)) ;
      player.sendMove(dst);
      player.sendTurn(fltRand(-90,90)) ;
      player.cvSee.lockWait() ;

      player.currentState().describe(cout) ;
      player.currentState().self().describe(cout) ;
      player.currentState().ball().describe(cout) ;
//      sleep(1,0);
   } 

   return 0 ;
} ;


//======================================================================
// sub2

int sub2(int argc, char** argv) {

//   ITK_SET_VBS(100) ;

   ThreadedPlayer player ;
   
   player.init() ;

   player.describe(cout) ;

   player.forkSensor() ;

   while(True) {
      Pos dst(fltRand(-50,0),fltRand(-30,30)) ;
      player.sendMove(dst);
      player.cvSee.lockWait() ;

      
      PosDir posdir ;  Flt posConf ;
      Vec vel ; Flt velConf ;
      Bool outOfFieldP ;

/* version 2
	 estimatePosDirVelTeam2(posdir,posConf,vel,velConf,outOfFieldP,
				player.sinfo.see, player.side) ;
*/

	 estimatePosDirVelTeam3(posdir,posConf,vel,velConf,outOfFieldP,
				player.sinfo.see, player.side) ;

	 ITK_DBG(dst) ;
	 ITK_DBG(posdir) ;
	 ITK_DBG(posConf) ;
	 ITK_DBG(vel) ;
	 ITK_DBG(velConf) ;
	 ITK_DBG(outOfFieldP) ;
   }
   
   return 0 ;

} ;


//======================================================================
// sub1

int sub1(int argc, char** argv) {

//   ITK_SET_VBS(100) ;

   BasePlayer player ;
   
   player.init() ;

   player.describe(cout) ;

   while(True) {
      Pos dst(fltRand(-50,0),fltRand(-30,30)) ;
      player.sendMove(dst);
      player.cycleSensor() ;
      if(player.sinfo.type == SensorInfo::T_See) {

	 PosDir posdir ;  Flt posConf ;
	 Vec vel ; Flt velConf ;
	 Bool outOfFieldP ;

/* version 2
	 estimatePosDirVelTeam2(posdir,posConf,vel,velConf,outOfFieldP,
				player.sinfo.see, player.side) ;
*/

	 estimatePosDirVelTeam3(posdir,posConf,vel,velConf,outOfFieldP,
				player.sinfo.see, player.side) ;

	 ITK_DBG(dst) ;
	 ITK_DBG(posdir) ;
	 ITK_DBG(posConf) ;
	 ITK_DBG(vel) ;
	 ITK_DBG(velConf) ;
	 ITK_DBG(outOfFieldP) ;
      }
      
   }

   return 0 ;

} ;

//======================================================================
// Main

int main(int argc, char** argv) {
   //sub1(argc,argv) ;
   //sub2(argc,argv) ;
   //sub3(argc,argv) ;
   //sub4(argc,argv) ;
   sub5(argc,argv) ;
   return 0 ;
} ;
   

